{% extends 'base.html.twig' %}

{% block site_nav_active app.user is same as(user) ? 'user' %}
{% block user_toolbox_active app.request.attributes.get('_route') %}

{% block sidebar %}
  {% from '_macros/time.html.twig' import relative_time %}

  <section class="sidebar__section sidebar-card">
    <h1 class="sidebar__title no-margin break-text">
      <a href="{{ path('user', {username: user.username}) }}" class="user-bio__user-link">{{ user.username }}</a>
    </h1>

    <p>
      <small class="fg-muted text-md">{{ 'user.registered'|trans({
        '%timestamp%': relative_time(user.created, { time_format: 'none', natural: true })
      })|raw }}
      </small>
    </p>

    {% if user.biography is not empty %}
      <div class="user-bio__biography">{{ user.biography|cached_markdown({ context: 'user_biography', user: user })|raw }}</div>
    {% endif %}
  </section>

  {% set active_ban = user.activeBan %}

  {% if is_granted('ROLE_ADMIN') and active_ban %}
    <section class="sidebar__section sidebar-card bg-red">
      <h1 class="sidebar__title">{{ 'heading.this_user_is_banned'|trans }}</h1>

      <dl class="definition-list">
        <dt>{{ 'label.reason'|trans }}</dt>
        <dd>{{ active_ban.reason }}</dd>

        <dt>{{ 'label.banned_by'|trans }}</dt>
        <dd>
          <a href="{{ path('user', { username: active_ban.bannedBy.username }) }}">
            {{- active_ban.bannedBy.username -}}
          </a>
        </dd>

        <dt>{{ 'label.expires'|trans }}</dt>
        <dd>
          {%- if active_ban.expiresAt -%}
            {{ relative_time(active_ban.expiresAt) }}
          {%- else -%}
            <small class="fg-muted text-md">{{ 'label.never'|trans }}</small>
          {%- endif -%}
        </dd>
      </dl>

      <p>
        <a href="{{ path('unban_user', { username: user.username }) }}"
           class="button">
          {{- 'action.unban'|trans -}}
        </a>
      </p>
    </section>
  {% endif %}

  {% set toolbox_items = {
    ('user.message'|trans): {
      route: 'compose_message',
      condition: is_granted('ROLE_USER') and user is not same as(app.user) and is_granted('message', user),
    },
    ('nav.block_user'|trans): {
      route: 'block_user',
      condition: is_granted('ROLE_USER') and user is not same as(app.user) and not app.user.isBlocking(user),
    },
    ('action.ban'|trans): {
      route: 'ban_user',
      condition: is_granted('ROLE_ADMIN') and user is not same as(app.user) and not active_ban,
    },
    ('nav.forum_bans'|trans): {
      route: 'user_forum_bans',
      condition: is_granted('ROLE_ADMIN')
    },
    ('nav.edit_biography'|trans): {
      route: 'edit_biography',
      condition: is_granted('ROLE_USER') and user is same as(app.user)
    },
    ('nav.hidden_forums'|trans): {
      route: 'hidden_forums',
      condition: is_granted('ROLE_USER') and user is same as(app.user)
    }
  } %}

  {% set open = false %}
  {% for label in toolbox_items|keys|sort|filter(label => toolbox_items[label].condition) %}
    {% if loop.first %}
      {% set open = true %}
      <section class="sidebar__section sidebar-card">
        <h1 class="sidebar__title">{{ 'label.toolbox'|trans }}</h1>
        <ul class="no-margin unlistify sidebar__no-padding">
    {% endif %}
    {% set item = toolbox_items[label] %}
    <li>
      <a href="{{ path(item.route, { username: user.username }) }}"
         class="menu-item {{ block('user_toolbox_active') == item.route ? 'menu-item--active' }}">
        {{- label -}}
      </a>
    </li>
  {% endfor %}
  {% if open %}
        </ul>
      </section>
  {% endif %}

  {% if is_granted('ROLE_ADMIN') %}
    <section class="sidebar__section sidebar-card">
      <h1 class="sidebar__title">{{ 'heading.user_roles'|trans }}</h1>
      <form action="{{ path(user.trusted ? 'mark_user_untrusted' : 'mark_user_trusted', {username: user.username}) }}" method="post" class="form">
        <input type="hidden" name="token" value="{{ csrf_token('mark_trusted') }}">
        <div class="form__row">
          <button class="button button--secondary">{{ (not user.trusted ? 'action.mark_as_trusted' : 'action.mark_as_untrusted')|trans }}</button>
        </div>
      </form>
    </section>
  {% endif %}

  {% if user.moderatorTokens|length > 0 %}
    <section class="sidebar__section sidebar-card">
      <h1 class="sidebar__title break-text">{{ 'user.moderates'|trans({'%username%': user.username}) }}</h1>

      <ul class="unlistify nav nav--guttered nav--slim-gutters">
        {% for token in user.moderatorTokens %}
          <li>
            <a href="{{ path('forum', {forum_name: token.forum.name}) }}"
               class="button button--secondary button--small">
              {{- token.forum.name -}}
            </a>
          </li>
        {% endfor %}
      </ul>
    </section>
  {% endif %}
{% endblock %}
